from ..public.db import findUser
from ..public.utils import checkData, signCode, findGroup
from ..public.crawler import Crawler
import json

def check(request):
    """
    校验数据
    目标内容 cid,pwd,phone
    """
    try:
        data = request.json
        if not checkData(data):
            raise Exception
        if not data.__contains__('cid'):
            raise Exception
        if not data.__contains__('pwd'):
            raise Exception
        return data, 200
    except Exception as e:
        print(e)
        return '数据不合法', 400

def manageLogin(request):
    """
    用户登录
    """
    # 校验数据
    check_res = check(request)
    # 抛出错误
    if check_res[-1] != 200:
        return check_res
    data = check_res[0]
    # 查找用户
    find_res = findUser(data['cid'])
    # 抛出错误
    if find_res[-1] != 200:
        return find_res[0], 510
    user_info = find_res[0]
    # 无用户进行注册
    if not user_info:
        return sign(data['cid'], data['pwd'])
    # 校验密码
    if user_info['pwd'] != signCode(data['pwd']):
        return '账号或密码错误', 511
    # 接下来需要返回组信息，课表信息以及成绩信息

    # 组信息
    find_res  = manageFindGroup(user_info['group_list'])
    if find_res[-1] != 200:
        return find_res
    user_info['group_list'] = find_res[0]
    
    # 课表信息以及成绩信息
    crawler_res = manageCrawler(user_info['cid'], user_info['pwd'], user_info.get('phone'))
    if crawler_res[-1] != 200:
        return crawler_res


def manageFindGroup(group_list):
    """
    根据组id查询组信息
    """
    list = []
    for group_id in group_list:
        find_res = findGroup(group_id)
        if find_res[-1] != 200:
            return find_res[0], 512
        list.append(find_res[0])
    return list, 200

def manageCrawler(cid, pwd, phone):
    """
    处理爬虫，返回课表和成绩
    """
    try:
        c = Crawler()
        init_res = c.defaultInit(cid, pwd, phone)
        if init_res[-1] != 200:
            return init_res
        get_res = c.getOwnSchedule()
        if get_res[-1] != 200:
            return get_res
        schedule = get_res[0]
        get_res = c.getGrade()
        if get_res[-1] != 200:
            return get_res
        grade = get_res[0]
        return {
            'grade': grade,
            'schedule': schedule,
        }, 200
    except Exception as e:
        print(e)
        return '教务挂了', 515

def manageSign(cid, pwd, phone):
    """
    用户注册
    """
    pass